﻿Public Class classFocusSound

    Dim gsService As New Intergraph.GeoMedia.PClient.GeometryStorageService
    Dim distService As New Intergraph.GeoMedia.PPipe.DistanceService
    Dim polylineGeometrySound As New Intergraph.GeoMedia.PBasic.PolylineGeometry
    Dim polylineGeometrySoundCollection As New Intergraph.GeoMedia.PBasic.GeometryCollection
    Dim blobGeometrySound As Object

    Dim dbldBDay, dbldBEvening, dbldBNight As Double

    Dim dblfrequency As Double
    Dim dblAttenuationCoef As Double
    Dim dblRadius As Double

    Dim pointCalculate As Object
    Dim dblDistanceToPoint As Double
    Dim dblAttenuationPoint As Double

    Dim dblXmin, dblXmax, dblYmin, dblYmax As Double

    Dim classOk As Boolean = True


    Public Sub New(ByVal geometryValue As Object)
        Dim geometryObject As New Object
        Dim polylineGeometryTemp As Intergraph.GeoMedia.PBasic.PolylineGeometry
        Dim nCount As Integer
        Dim dblX, dblY As Double

        blobGeometrySound = geometryValue

        'Obtenim la geometria
        polylineGeometrySound = New Intergraph.GeoMedia.PBasic.PolylineGeometry
        gsService.StorageToGeometry(blobGeometrySound, geometryObject)
        Select Case geometryObject.Type
            Case "OrientedPointGeometry"
                polylineGeometrySound.Points.Add(geometryObject.origin, 1)
                polylineGeometrySoundCollection.Add(polylineGeometrySound)
            Case "PolylineGeometry"
                polylineGeometrySound = geometryObject
                polylineGeometrySoundCollection.Add(polylineGeometrySound, 1)
            Case "GeometryCollection"
                polylineGeometrySoundCollection = geometryObject
            Case Else
                MsgBox("Geometria del focus de so no reconeguda")
                classOk = False
                Exit Sub
        End Select

        'Busquem la coordenada mínima i la màxima
        dblXmin = polylineGeometrySoundCollection.Item(1).Points.Item(1).X
        dblYmin = polylineGeometrySoundCollection.Item(1).Points.Item(1).Y
        dblXmax = polylineGeometrySoundCollection.Item(1).Points.Item(1).X
        dblYmax = polylineGeometrySoundCollection.Item(1).Points.Item(1).Y

        For Each polylineGeometryTemp In polylineGeometrySoundCollection
            For nCount = 1 To polylineGeometryTemp.Points.Count
                dblX = polylineGeometryTemp.Points.Item(nCount).X
                dblY = polylineGeometryTemp.Points.Item(nCount).Y
                If dblX < dblXmin Then dblXmin = dblX
                If dblX > dblXmax Then dblXmax = dblX
                If dblY < dblYmin Then dblYmin = dblY
                If dblY > dblYmax Then dblYmax = dblY
            Next
        Next

        'Inicialitzem els valors
        setDbValues(0, 0, 0)
        dblAttenuationCoef = 0
        dblfrequency = 0
        dblRadius = 0


    End Sub

    Public Function rightClass() As Boolean
        'Ens diu si hem reconegut la geometria
        Return classOk
    End Function

    'Public Function getX(ByVal pointNumber As Integer) As Double
    '    'Ens torna el valor de la x del punt pointNumber
    '    Return polylineGeometrySound.Points.Item(pointNumber).X
    'End Function

    'Public Function getY(ByVal pointNumber As Integer) As Double
    '    'Ens torna el valor de la y del punt pointNumber
    '    Return polylineGeometrySound.Points.Item(pointNumber).Y
    'End Function

    Public Function getXmin()
        'Ens torna el valor de la x mínima de la geometria
        Return dblXmin
    End Function

    Public Function getXmax()
        'Ens torna el valor de la x màxima de la geometria
        Return dblXmax
    End Function

    Public Function getYmin()
        'Ens torna el valor de la y mínima de la geometria
        Return dblYmin
    End Function

    Public Function getYmax()
        'Ens torna el valor de la y màxima de la geometria
        Return dblYmax
    End Function

    Public Function countPoints() As Integer
        'Ens torna la quantitat de punts
        Return polylineGeometrySound.Points.Count
    End Function

    Public Function getDistance() As Double
        'Ens torna la distancia al punt d’avaluació
        Return dblDistanceToPoint
    End Function

    Public Function getdBPointDay() As Double
        'Ens torna la pressió Day sonora en el punt d’avaluació
        Dim value As Double
        value = dbldBDay - dblAttenuationPoint
        If value < 0 Then value = 0
        Return value
    End Function

    Public Function getdBPointEvening() As Double
        'Ens torna la pressió Evening sonora en el punt d’avaluació
        Dim value As Double
        value = dbldBEvening - dblAttenuationPoint
        If value < 0 Then value = 0
        Return value
    End Function

    Public Function getdBPointdBNight() As Double
        'Ens torna la pressió Night sonora en el punt d’avaluació
        Dim value As Double
        value = dbldBNight - dblAttenuationPoint
        If value < 0 Then value = 0
        Return value
    End Function

    Public Function getRadius() As Double
        'Ens torna la distancia a la que la pressió sonora es nul·la
        Return dblRadius
    End Function

    Public Sub setPoint(ByVal geometryPoint As Object)
        'Establim el punt d’avaluació
        pointCalculate = geometryPoint
        'Establim la distancia a la geometria
        distanceCalculator()
        'Calcula la atenuació del punt
        dblAttenuationPoint = attenuationCalculator(dblDistanceToPoint)
    End Sub

    Public Sub setDbValues(ByVal dBDay As Double, ByVal dBEvening As Double, ByVal dBNight As Double)
        'Establim les potencies sonores de la font 
        dbldBDay = dBDay
        dbldBEvening = dBEvening
        dbldBNight = dBNight
    End Sub

    Public Sub setFrequency(ByVal frequency As Double)
        'Establim la freqüència característica de la font
        dblfrequency = frequency
    End Sub

    Public Sub setAttenuationCoef(ByVal attenuationCoef As Double)
        'Establim el coeficient d’atenuació atmosfèrica i el radi 
        Dim dblMax As Double
        Dim dblX1, dblY1, dblX2, dblY2 As Double
        Dim bolFind As Boolean
        Dim IntItera As Integer

        'Col·loquem el coeficient atmosfèric d'absorció
        dblAttenuationCoef = attenuationCoef

        'Calculem el dB màxim
        dblMax = Math.Max(dbldBDay, dbldBEvening)
        dblMax = Math.Max(dblMax, dbldBNight)

        'Iniciem el valors per a la iteració
        bolFind = False
        dblX1 = 1
        dblY1 = attenuationCalculator(dblX1)
        dblX2 = 10000
        dblY2 = attenuationCalculator(dblX2)

        'Comencem la iteració
        IntItera = 0
        Do
            IntItera = IntItera + 1
            'Aproximació logarítmica descartada per oscil·lació
            'dblA = (dblY2 - dblY1) / Math.Log(dblX2, 10)
            'dblX2 = 10 ^ ((dblMax - dblY1) / dblA)

            'Aproximació lineal convergent per acotada
            dblX2 = (dblX2 * (dblMax - dblY1) - dblX1 * (dblMax - dblY2)) / (dblY2 - dblY1)

            'Comprovem el resultat
            dblY2 = attenuationCalculator(dblX2)
            If Math.Round(dblY2, 2) = Math.Round(dblMax, 2) Then Exit Do
            If IntItera > 20 Then Exit Do
        Loop

        dblRadius = Math.Round(dblX2, 2)

    End Sub

    Private Function attenuationCalculator(ByVal dblDist As Double) As Double
        'Calculem la atenuació a una distancia donada
        Dim dbldbAttenuation As Double
        'Calculem si tenim la distancia i el coeficient atmosfèric d’absorció 
        If Not dblDist = 0 And Not dblAttenuationCoef = 0 Then
            If polylineGeometrySound.Points.Count = 1 Then
                'Es esfèric
                dbldbAttenuation = 11 + dblAttenuationCoef * dblDist + 20 * Math.Log(dblDist, 10)
            Else
                'No es esfèric, pel que es cilíndric
                dbldbAttenuation = 8 + dblAttenuationCoef * dblDist + 10 * Math.Log(dblDist, 10)
            End If
        End If
        Return dbldbAttenuation
    End Function

    Private Sub distanceCalculator()
        'Calculem la distancia entre punt d’avaluació i la geometria
        Dim dblDistance As Double

        With distService
            .FirstGeometry = pointCalculate
            .SecondGeometry = blobGeometrySound
        End With
        dblDistance = distService.Distance()

        'Per distancies inferiors a 1 els logaritmes ens sortirien negatius.
        If dblDistance < 1 Then dblDistance = 1

        dblDistanceToPoint = dblDistance
    End Sub

End Class
