Public Class frmCalcPresure
    Dim geoApp As Intergraph.GeoMedia.GeoMedia.Application
    Dim objDoc As Intergraph.GeoMedia.GeoMedia.Document
    Dim objConnections As Intergraph.GeoMedia.PClient.Connections

    'Carreguem el formulari
    Private Sub frmCalcPresure_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim objConnect As Intergraph.GeoMedia.PClient.Connection

        'Assignem l'aplicaci
        geoApp = GetObject(, "GeoMedia.Application")

        'Assignem el workspace obert
        If geoApp.Windows.Count > 0 Then
            objDoc = geoApp.Document
        Else
            MsgBox("No tenim WorkSapce")
            Hide()
            Exit Sub
        End If

        'Llegim les connexions que tenim
        objConnections = objDoc.Connections
        If objConnections.Count = 0 Then
            MsgBox("No tenim Connexions")
            Hide()
            Exit Sub
        End If

        'Enumerem les connexions i omplim el combobox
        comboConnections.Items.Clear()
        Dim arr As ArrayList = New ArrayList()
        For Each objConnect In objConnections
            comboConnections.Items.Add(objConnect)
        Next
        comboConnections.DisplayMember = "Name"
        comboConnections.SelectedIndex = 0

    End Sub

    'Tanquem el formulari
    Private Sub cmdHide_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdHide.Click
        Hide()
    End Sub

    'Executem l'aplicaci
    Private Sub cmdCalculate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCalculate.Click
        Dim connSoundMap As Intergraph.GeoMedia.PClient.Connection

        'Seleccionem la connexi
        connSoundMap = comboConnections.SelectedItem

        'Netegem taules
        writeLabel("Netejant les dades anteriors", 1)
        cleanTables(connSoundMap)

        'Treballem la taula de focus puntuals
        writeLabel("Processant focus puntuals", 1)
        setGridPoints("SoundPointFocus", connSoundMap)

        'Treballem la taula de focus Lineals
        writeLabel("Processant focus lineals", 1)
        setGridPoints("SoundLineFocus", connSoundMap)

        'Omplim la taula de punts mesurats resultants
        writeLabel("Omplint la taula de valors resultants", 1)
        putPointPressureValues(connSoundMap)

        'Calculem Lden dels punts mesurats resultants
        writeLabel("Calculant Lden dels punts mallats", 1)
        LdenCalculate(connSoundMap)

        'Actualitzem la vista
        writeLabel("Refrescant la vista", 1)
        viewRefresh(geoApp, connSoundMap)

        'Donem el missatge de finalitzat
        writeLabel("YaTa", 1)

    End Sub

    'Creem l'objecte font sonora, la quadricula i establim la taula intermdia amb els punts i els seus valors
    Private Sub setGridPoints(ByVal strSoundFocus As String, ByVal conn As Object)

        Dim connSoundMap As Intergraph.GeoMedia.PClient.Connection
        Dim rdsSoundFocus As Intergraph.GeoMedia.PClient.GRecordset
        Dim rdsGridPoints As Intergraph.GeoMedia.PClient.GRecordset
        Dim rdsTmpPointsValue As Intergraph.GeoMedia.PClient.GRecordset

        Dim gsService As New Intergraph.GeoMedia.PClient.GeometryStorageService

        Dim dblX1 As Double, dblX2 As Double, dblY1 As Double, dblY2 As Double, dblX As Double, dblY As Double

        Dim dbltxtXMin, dbltxtXMax, dbltxtYMin, dbltxtYMax As Double

        Dim dblSideGrid As Double, dblRadius As Double

        Dim geometryPointCenter As Intergraph.GeoMedia.PBasic.PointGeometry
        Dim blobPointCenter As Object

        Dim clFocusSound As classFocusSound

        'Llegim la mida de la malla
        dblSideGrid = CDbl(txtSideGrid.Text)

        'Llegim els valors del quadre d'estudi i arrodonim.
        dbltxtXMin = (Int(CDbl(txtXMin.Text) / dblSideGrid)) * dblSideGrid
        dbltxtXMax = (Int(CDbl(txtXMax.Text) / dblSideGrid) + 1) * dblSideGrid
        dbltxtYMin = (Int(CDbl(txtYMin.Text) / dblSideGrid)) * dblSideGrid
        dbltxtYMax = (Int(CDbl(txtYMax.Text) / dblSideGrid) + 1) * dblSideGrid

        'Obrim la base de dades del soroll i la taula de focus de soroll que treballem 
        connSoundMap = conn
        rdsTmpPointsValue = giveRecordset("TempPointsPressures", connSoundMap)
        rdsSoundFocus = giveRecordset(strSoundFocus, connSoundMap)

        If rdsSoundFocus.RecordCount > 0 Then
            rdsSoundFocus.MoveFirst()
            Do While rdsSoundFocus.EOF = False

                'Creem l'objecte focus de so
                clFocusSound = New classFocusSound(rdsSoundFocus.GFields("Geometry").Value)
                'Si la classe s reconeguda, recobrim amb la malla
                If clFocusSound.rightClass Then

                    'Colloquem els parmetres al focus
                    clFocusSound.setDbValues(rdsSoundFocus.GFields("dBDay").Value, _
                                             rdsSoundFocus.GFields("dBEvening").Value, _
                                             rdsSoundFocus.GFields("dBNight").Value)
                    clFocusSound.setFrequency(rdsSoundFocus.GFields("soundHz").Value)
                    clFocusSound.setAttenuationCoef(rdsSoundFocus.GFields("attenuationCoeff").Value)

                    'Obtenim el radi mxim del so
                    dblRadius = clFocusSound.getRadius
                    If dblRadius < 2 * dblSideGrid Then dblRadius = 2 * dblSideGrid
                    If dblRadius > CDbl(txtRadiusMax.Text) Then dblRadius = CDbl(txtRadiusMax.Text)
                    dblRadius = (Int(dblRadius / dblSideGrid) + 1) * dblSideGrid    'Volem arrodonir a l'ala

                    'Escrivim en pantalla el focus que processem
                    writeLabel("Focus " & rdsSoundFocus.GFields("idSoundFocus").Value.ToString & " radi " & dblRadius.ToString & " m", 2)

                    'Mesurem les coordenades del punt central del quadrat "inferior esquerra"
                    dblX1 = Int(clFocusSound.getXmin / dblSideGrid) * dblSideGrid
                    dblY1 = Int(clFocusSound.getYmin / dblSideGrid) * dblSideGrid

                    'Definim el punt central del quadrat "superior dret"
                    dblX2 = dblSideGrid + Int(clFocusSound.getXmax / dblSideGrid) * dblSideGrid
                    dblY2 = dblSideGrid + Int(clFocusSound.getYmax / dblSideGrid) * dblSideGrid

                    'Colloquem el radi
                    dblX1 = dblX1 - dblRadius
                    dblY1 = dblY1 - dblRadius
                    dblX2 = dblX2 + dblRadius
                    dblY2 = dblY2 + dblRadius

                    'Tallem pels valors mxims
                    If dblX1 < dbltxtXMin Then dblX1 = dbltxtXMin
                    If dblX2 > dbltxtXMax Then dblX2 = dbltxtXMax
                    If dblY1 < dbltxtYMin Then dblY1 = dbltxtYMin
                    If dblY2 > dbltxtYMax Then dblY2 = dbltxtYMax

                    'Ens movem en el interval
                    dblY = dblY1
                    dblY2 = dblY2 + dblSideGrid / 2 'Tamb volem processar quan tinguem dblY2 i dblX2
                    dblX2 = dblX2 + dblSideGrid / 2
                    Do While dblY < dblY2
                        dblX = dblX1
                        Do While dblX < dblX2
                            'Creem el punt de mesura que es el punt central del quadrat de la malla
                            geometryPointCenter = New Intergraph.GeoMedia.PBasic.PointGeometry
                            With geometryPointCenter
                                .Origin.X = dblX
                                .Origin.Y = dblY
                                .Origin.Z = 0
                            End With
                            'Convertim la geometria per muntar el filtre que ens dir si existeix el quadrat
                            blobPointCenter = New Object
                            gsService.GeometryToStorage(geometryPointCenter, blobPointCenter)
                            'Apliquem el filtre
                            rdsGridPoints = giveRecordset("PointPressure", connSoundMap, blobPointCenter, _
                                                        Intergraph.GeoMedia.PClient.GConstants.gdbTouches)
                            'Si tenim valors s el quadrat, si no l'hem de crear
                            If rdsGridPoints.RecordCount = 0 Then
                                squareCreate(geometryPointCenter, dblSideGrid, rdsGridPoints)
                            End If

                            'Colloquem al objecte focus el punt dels clculs
                            clFocusSound.setPoint(blobPointCenter)

                            'Obtenim els valors i els colloquem en la taula intermdia
                            With rdsTmpPointsValue
                                'Dia
                                .AddNew()
                                .GFields("idPointPressure").Value = rdsGridPoints.GFields("idPointPressure").Value
                                .GFields("focusType").Value = rdsSoundFocus.GFields("focusType").Value
                                .GFields("soundTime").Value = "dBDay"
                                .GFields("valuePointPressure").Value = clFocusSound.getdBPointDay
                                .Update()
                                'Tarda
                                .AddNew()
                                .GFields("idPointPressure").Value = rdsGridPoints.GFields("idPointPressure").Value
                                .GFields("focusType").Value = rdsSoundFocus.GFields("focusType").Value
                                .GFields("soundTime").Value = "dBEvening"
                                .GFields("valuePointPressure").Value = clFocusSound.getdBPointEvening
                                .Update()
                                'Nit
                                .AddNew()
                                .GFields("idPointPressure").Value = rdsGridPoints.GFields("idPointPressure").Value
                                .GFields("focusType").Value = rdsSoundFocus.GFields("focusType").Value
                                .GFields("soundTime").Value = "dBNight"
                                .GFields("valuePointPressure").Value = clFocusSound.getdBPointdBNight
                                .Update()
                            End With

                            'Passem al segent quadrat
                            rdsGridPoints.Close()
                            dblX = dblX + dblSideGrid
                        Loop
                        dblY = dblY + dblSideGrid
                    Loop
                End If
                'Passem al focus segent
                rdsSoundFocus.MoveNext()
            Loop
        End If
        'Tanquem la taula de focus 
        rdsSoundFocus.Close()
        'Tanquem la taula de valors intermedis
        rdsTmpPointsValue.Close()
    End Sub

    'Processem els valors de TempPointsPressures
    Private Sub putPointPressureValues(ByVal conn As Object)
        Dim connSoundMap As Intergraph.GeoMedia.PClient.Connection
        Dim dbSoundMap As Intergraph.GeoMedia.PClient.GDatabase

        Dim strPivotSql As String
        Dim rdsPivot As Intergraph.GeoMedia.PClient.GRecordset
        Dim rdsPointPressureValues As Intergraph.GeoMedia.PClient.GRecordset

        Dim nCount As Integer

        Dim lngIdPPV, lngIdPivot As Long
        Dim intPivotFields As Integer
        Dim strSoundTime As String
        Dim dblLogarithmicSum, dblValue As Double

        connSoundMap = conn
        dbSoundMap = connSoundMap.Database

        'Muntem la taula pivotant
        strPivotSql = "TRANSFORM MAX(valuePointPressure) AS MaxValue SELECT idPointPressure, soundTime " _
                    & "FROM TempPointsPressures GROUP BY idPointPressure, soundTime " _
                    & "ORDER BY idPointPressure ASC, soundTime ASC PIVOT focusType"
        rdsPivot = dbSoundMap.OpenRecordset(strPivotSql)
        If Not rdsPivot.RecordCount = 0 Then
            intPivotFields = rdsPivot.GFields.Count

            'Obrim la taula dels punts 
            rdsPointPressureValues = dbSoundMap.OpenRecordset("Select * From PointPressure ORDER BY idPointPressure ASC")
            If Not rdsPointPressureValues.RecordCount = 0 Then

                'Ens movem als valors inicials
                rdsPivot.MoveFirst()
                rdsPointPressureValues.MoveFirst()
                lngIdPPV = rdsPointPressureValues.GFields("idPointPressure").Value
                lngIdPivot = rdsPivot.GFields("idPointPressure").Value

                'Recorrerem les taules que estan ordenades en parallel
                Do While rdsPivot.EOF = False And rdsPointPressureValues.EOF = False
                    Do While lngIdPPV = lngIdPivot

                        strSoundTime = rdsPivot.GFields("soundTime").Value
                        dblLogarithmicSum = 0

                        'Sumem els valors del pivot, que son valors de presio sonora.
                        For nCount = 2 To intPivotFields - 1
                            If Not IsDBNull(rdsPivot.GFields(nCount).Value) Then
                                dblValue = rdsPivot.GFields(nCount).Value
                                If Not dblValue = 0 Then
                                    dblLogarithmicSum = dblLogarithmicSum + (10 ^ (dblValue / 10))
                                End If
                            End If
                        Next
                        If Not dblLogarithmicSum = 0 Then dblLogarithmicSum = 10 * Math.Log(dblLogarithmicSum, 10)
                        'Guardem els valors
                        rdsPointPressureValues.Edit()
                        rdsPointPressureValues.GFields(strSoundTime).Value = dblLogarithmicSum
                        rdsPointPressureValues.Update()
                        'Seleccionem el registre segent de la taula pivotant
                        rdsPivot.MoveNext()
                        If rdsPivot.EOF = True Then Exit Do
                        lngIdPivot = rdsPivot.GFields("idPointPressure").Value
                    Loop
                    'Busquem el segent registre
                    rdsPointPressureValues.MoveNext()
                    If rdsPointPressureValues.EOF = True Then Exit Do
                    lngIdPPV = rdsPointPressureValues.GFields("idPointPressure").Value

                    'Si no son iguals hem de buscar els segents iguals
                    Do Until lngIdPPV = lngIdPivot
                        If lngIdPPV > lngIdPivot Then
                            rdsPivot.MoveNext()
                            If rdsPivot.EOF = True Then Exit Do
                            lngIdPivot = rdsPivot.GFields("idPointPressure").Value
                        Else
                            rdsPointPressureValues.MoveNext()
                            If rdsPointPressureValues.EOF = True Then Exit Do
                            lngIdPPV = rdsPointPressureValues.GFields("idPointPressure").Value
                        End If
                    Loop

                Loop
            End If
        End If

    End Sub

    'Retornem el recorset segons les especificacions donades
    Function giveRecordset(ByVal strTable As String, ByVal conn As Object, _
                           Optional ByVal blobFilter As Object = Nothing, _
                           Optional ByVal operatorFilter As Short = 0) As Object
        Dim rdsPipe As Intergraph.GeoMedia.PClient.GRecordset
        Dim orgPipe As Intergraph.GeoMedia.PClient.OriginatingPipe
        Dim connPipe As Intergraph.GeoMedia.PClient.Connection

        'Creem la cua i muntem el recordset
        connPipe = conn
        orgPipe = Nothing
        connPipe.CreateOriginatingPipe(orgPipe)

        With orgPipe
            .GeometryFieldName = "Geometry"
            .Table = strTable
            If Not IsNothing(blobFilter) Then
                .SpatialFilter = blobFilter
                .SpatialOperator = operatorFilter
            End If
        End With

        rdsPipe = orgPipe.OutputRecordset
        giveRecordset = rdsPipe
        orgPipe = Nothing

    End Function

    'Creem un quadrat donat el centre, el costat i el guardem el la taula donada
    Private Sub squareCreate(ByVal geometryPointCenter As Object, ByVal dblSide As Double, ByVal rdsGRectangles As Object)
        Dim gsService As New Intergraph.GeoMedia.PClient.GeometryStorageService
        Dim geometryRectangle As New Intergraph.GeoMedia.PBasic.RectangleGeometry
        Dim blobRectangle As New Object

        'Creem els rectangles
        With geometryRectangle
            .Origin.X = geometryPointCenter.Origin.x - dblSide / 2
            .Origin.Y = geometryPointCenter.Origin.y + dblSide / 2
            .Origin.Z = geometryPointCenter.Origin.z
            .Height = dblSide
            .Width = dblSide
            .Rotation = 0
        End With

        'Convertim la geometria
        gsService.GeometryToStorage(geometryRectangle, blobRectangle)

        'Afegim el rectangle
        rdsGRectangles.AddNew()
        rdsGRectangles.GFields("Geometry").Value = blobRectangle
        rdsGRectangles.Update()

    End Sub

    'Eliminem les dades de processos anteriors
    Private Sub cleanTables(ByVal conn As Object)

        Dim connSoundMap As Intergraph.GeoMedia.PClient.Connection
        Dim dbSoundMap As Intergraph.GeoMedia.PClient.GDatabase
        Dim rdsTmp As Intergraph.GeoMedia.PClient.GRecordset

        connSoundMap = conn
        dbSoundMap = connSoundMap.Database
        'Eliminem les dades intermedies
        rdsTmp = dbSoundMap.OpenRecordset("Select * From TempPointsPressures")
        With rdsTmp
            If Not .RecordCount = 0 Then
                .MoveFirst()
                Do While .EOF = False
                    .Delete()
                    .MoveNext()
                Loop
            End If
        End With
        rdsTmp.Close()
        'Anullem els valors anteriors
        rdsTmp = dbSoundMap.OpenRecordset("Select * From PointPressure")
        With rdsTmp
            If Not .RecordCount = 0 Then
                .MoveFirst()
                Do While .EOF = False
                    .Edit()
                    .GFields("valuePointPressure").Value = 0
                    .GFields("dBDay").Value = 0
                    .GFields("dBEvening").Value = 0
                    .GFields("dBNight").Value = 0
                    .Update()
                    .MoveNext()
                Loop
            End If
        End With
        rdsTmp.Close()

    End Sub

    'Actualitzem la MapWindow amb les actualitzacions dels magatzem per veure el resultat
    Private Sub viewRefresh(ByVal geoApp As Object, ByVal geoConn As Object)

        Dim mapWin As Intergraph.GeoMedia.GeoMedia.MapWindow
        Dim mapView As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim mapLegend As Intergraph.GeoMedia.PView.Legend
        Dim mapLegendEntry As Intergraph.GeoMedia.PView.LegendEntriesClass

        Dim nCount As Integer

        geoConn.ReloadDatabase()

        mapWin = geoApp.ActiveWindow
        mapView = mapWin.MapView
        mapLegend = mapView.Legend
        mapLegendEntry = mapLegend.LegendEntries

        For nCount = 1 To mapLegendEntry.Count
            mapLegendEntry(nCount).LoadData()
        Next nCount

        mapView.Refresh()

    End Sub

    'Escrivim els missatges d'estat
    Private Sub writeLabel(ByVal txtWrite As String, ByVal intLine As Integer)
        Select Case intLine
            Case 1
                lblControl1.Text = txtWrite
                lblControl2.Text = ""
            Case 2
                lblControl2.Text = txtWrite
        End Select
        Me.Refresh()
    End Sub

    'Calculem Lden perqu s molt usual necesitar-lo
    Private Sub LdenCalculate(ByVal conn As Object)
        Dim connSoundMap As Intergraph.GeoMedia.PClient.Connection
        Dim dbSoundMap As Intergraph.GeoMedia.PClient.GDatabase
        Dim rdsTmp As Intergraph.GeoMedia.PClient.GRecordset
        Dim dblValor As Double

        connSoundMap = conn
        dbSoundMap = connSoundMap.Database

        rdsTmp = dbSoundMap.OpenRecordset("Select * From PointPressure")
        With rdsTmp
            If Not .RecordCount = 0 Then
                .MoveFirst()
                Do While .EOF = False
                    dblValor = 0
                    'Els valors de la pressi sonora han de ser no nuls
                    If .GFields("dBDay").Value > 0 Then dblValor = 12 * (10 ^ (.GFields("dBDay").Value / 10))
                    If .GFields("dBEvening").Value > 0 Then dblValor = dblValor + 4 * (10 ^ ((.GFields("dBEvening").Value + 5) / 10))
                    If .GFields("dBNight").Value > 0 Then dblValor = dblValor + 8 * (10 ^ ((.GFields("dBNight").Value + 10) / 10))
                    If dblValor > 0 Then
                        dblValor = dblValor / 24
                        dblValor = Math.Log(dblValor, 10)
                        dblValor = Math.Round(10 * dblValor, 2)
                        If dblValor < 0 Then dblValor = 0
                    End If
                    .Edit()
                    .GFields("valuePointPressure").Value = dblValor
                    .Update()
                    .MoveNext()
                Loop
            End If
        End With
        rdsTmp.Close()

    End Sub

End Class

